/*
 * (C) Copyright IBM Corp. 2004
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   Konrad Rzeszutek <konradr@us.ibm.com>

 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18 2003/11/07 17:03:52 rstory Exp $
 *
 * $Id: saHpiSensorReadingMaxTable.h,v 1.2 2004/03/23 04:20:20 konradrzeszutek Exp $
 *
 */
#ifndef SAHPISENSORREADINGMAXTABLE_H
#define SAHPISENSORREADINGMAXTABLE_H

#ifdef __cplusplus
extern "C"
{
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>
#include <SaHpi.h>
#include <hpiSubagent.h>


	/** Index saHpiDomainID is external */
	/** Index saHpiResourceID is external */
	/** Index saHpiSensorIndex is external */

  typedef struct saHpiSensorReadingMaxTable_context_s
  {
    netsnmp_index index;
	/** INTEGER = ASN_INTEGER */
    long saHpiSensorReadingMaxValuesPresent;

	/** UNSIGNED32 = ASN_UNSIGNED */
    unsigned long saHpiSensorReadingMaxRaw;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorReadingMaxInterpreted[SENSOR_READING_INTER_MAX];
    size_t saHpiSensorReadingMaxInterpreted_len;

	/** INTEGER = ASN_INTEGER */
    long saHpiSensorReadingMaxStatus;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorReadingMaxEventStatus[SENSOR_READING_EVENT_MAX];
    size_t saHpiSensorReadingMaxEventStatus_len;

    long hash;
    SaHpiResourceIdT resource_id;
    SaHpiDomainIdT domain_id;
    SaHpiSensorNumT sensor_id;

  } saHpiSensorReadingMaxTable_context;

/*************************************************************
 * function declarations
 */

  void initialize_table_saHpiSensorReadingMaxTable (void);

  int
    delete_ReadingMax_row (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT num);

  int populate_ReadingMax (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT sensor_id,
			       SaHpiEventCategoryT sensor_category,
			       SaHpiSensorReadingT * reading);


  int
    saHpiSensorReadingMaxTable_get_value (netsnmp_request_info *,
					      netsnmp_index *,
					      netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
  extern oid saHpiSensorReadingMaxTable_oid[];
  extern size_t saHpiSensorReadingMaxTable_oid_len;

#define saHpiSensorReadingMaxTable_TABLE_OID hpiSensor_OID,2

/*************************************************************
 * column number definitions for table saHpiSensorReadingMaxTable
 */
#define COLUMN_SAHPISENSORREADINGMAXVALUESPRESENT 1
#define COLUMN_SAHPISENSORREADINGMAXRAW 2
#define COLUMN_SAHPISENSORREADINGMAXINTERPRETED 3
#define COLUMN_SAHPISENSORREADINGMAXSTATUS 4
#define COLUMN_SAHPISENSORREADINGMAXEVENTSTATUS 5
#define saHpiSensorReadingMaxTable_COL_MIN 1
#define saHpiSensorReadingMaxTable_COL_MAX 5

  int
    saHpiSensorReadingMaxTable_extract_index
    (saHpiSensorReadingMaxTable_context * ctx, netsnmp_index * hdr);

  void saHpiSensorReadingMaxTable_set_reserve1 (netsnmp_request_group *);
  void saHpiSensorReadingMaxTable_set_reserve2 (netsnmp_request_group *);
  void saHpiSensorReadingMaxTable_set_action (netsnmp_request_group *);
  void saHpiSensorReadingMaxTable_set_commit (netsnmp_request_group *);
  void saHpiSensorReadingMaxTable_set_free (netsnmp_request_group *);
  void saHpiSensorReadingMaxTable_set_undo (netsnmp_request_group *);

    saHpiSensorReadingMaxTable_context
    * saHpiSensorReadingMaxTable_duplicate_row
    (saHpiSensorReadingMaxTable_context *);
    netsnmp_index
    * saHpiSensorReadingMaxTable_delete_row
    (saHpiSensorReadingMaxTable_context *);

  int
    saHpiSensorReadingMaxTable_can_delete
    (saHpiSensorReadingMaxTable_context * undo_ctx,
     saHpiSensorReadingMaxTable_context * row_ctx,
     netsnmp_request_group * rg);



    saHpiSensorReadingMaxTable_context
    * saHpiSensorReadingMaxTable_create_row (netsnmp_index *);

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORREADINGMAXTABLE_H */
