/*
 * (C) Copyright IBM Corp. 2004
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   Konrad Rzeszutek <konradr@us.ibm.com>

 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18 2003/11/07 17:03:52 rstory Exp $
 *
 * $Id: saHpiSensorReadingMinTable.h,v 1.2 2004/03/23 04:20:20 konradrzeszutek Exp $
 *
 */
#ifndef SAHPISENSORREADINGMINTABLE_H
#define SAHPISENSORREADINGMINTABLE_H

#ifdef __cplusplus
extern "C"
{
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>
#include <SaHpi.h>
#include <hpiSubagent.h>


	/** Index saHpiDomainID is external */
	/** Index saHpiResourceID is external */
	/** Index saHpiSensorIndex is external */

  typedef struct saHpiSensorReadingMinTable_context_s
  {
    netsnmp_index index;
	/** INTEGER = ASN_INTEGER */
    long saHpiSensorReadingMinValuesPresent;

	/** UNSIGNED32 = ASN_UNSIGNED */
    unsigned long saHpiSensorReadingMinRaw;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorReadingMinInterpreted[SENSOR_READING_INTER_MAX];
    size_t saHpiSensorReadingMinInterpreted_len;

	/** INTEGER = ASN_INTEGER */
    long saHpiSensorReadingMinStatus;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorReadingMinEventStatus[SENSOR_READING_EVENT_MAX];
    size_t saHpiSensorReadingMinEventStatus_len;

    SaHpiResourceIdT resource_id;
    SaHpiDomainIdT domain_id;
    SaHpiSensorNumT sensor_id;
    long hash;


  } saHpiSensorReadingMinTable_context;

/*************************************************************
 * function declarations
 */

  void initialize_table_saHpiSensorReadingMinTable (void);

  int
    delete_ReadingMin_row (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT num);

  int populate_ReadingMin (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT sensor_id,
			       SaHpiEventCategoryT sensor_category,
			       SaHpiSensorReadingT * reading);


  int
    saHpiSensorReadingMinTable_get_value (netsnmp_request_info *,
					      netsnmp_index *,
					      netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
  extern oid saHpiSensorReadingMinTable_oid[];
  extern size_t saHpiSensorReadingMinTable_oid_len;

#define saHpiSensorReadingMinTable_TABLE_OID hpiSensor_OID,3

/*************************************************************
 * column number definitions for table saHpiSensorReadingMinTable
 */
#define COLUMN_SAHPISENSORREADINGMINVALUESPRESENT 1
#define COLUMN_SAHPISENSORREADINGMINRAW 2
#define COLUMN_SAHPISENSORREADINGMININTERPRETED 3
#define COLUMN_SAHPISENSORREADINGMINSTATUS 4
#define COLUMN_SAHPISENSORREADINGMINEVENTSTATUS 5
#define saHpiSensorReadingMinTable_COL_MIN 1
#define saHpiSensorReadingMinTable_COL_MAX 5

  int
    saHpiSensorReadingMinTable_extract_index
    (saHpiSensorReadingMinTable_context * ctx, netsnmp_index * hdr);

  void saHpiSensorReadingMinTable_set_reserve1 (netsnmp_request_group *);
  void saHpiSensorReadingMinTable_set_reserve2 (netsnmp_request_group *);
  void saHpiSensorReadingMinTable_set_action (netsnmp_request_group *);
  void saHpiSensorReadingMinTable_set_commit (netsnmp_request_group *);
  void saHpiSensorReadingMinTable_set_free (netsnmp_request_group *);
  void saHpiSensorReadingMinTable_set_undo (netsnmp_request_group *);

    saHpiSensorReadingMinTable_context
    * saHpiSensorReadingMinTable_duplicate_row
    (saHpiSensorReadingMinTable_context *);
    netsnmp_index
    * saHpiSensorReadingMinTable_delete_row
    (saHpiSensorReadingMinTable_context *);

  int
    saHpiSensorReadingMinTable_can_delete
    (saHpiSensorReadingMinTable_context * undo_ctx,
     saHpiSensorReadingMinTable_context * row_ctx,
     netsnmp_request_group * rg);



    saHpiSensorReadingMinTable_context
    * saHpiSensorReadingMinTable_create_row (netsnmp_index *);

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORREADINGMINTABLE_H */
